"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const db_1 = require("../../db");
const __1 = require("../../");
const path_1 = __importDefault(require("path"));
exports.default = {
    name: 'codegen',
    run: async (toolbox) => {
        const { config: { load } } = toolbox;
        const { config } = load();
        const server = new __1.Server({
            introspection: false,
            // mockDBConnection: true,
            tcgImportPath: config.TCG_MODULE_IMPORT_PATH,
            resolversPath: [path_1.default.join(process.cwd(), 'generated') + '/resolvers/*.resolver.ts']
        }, {
            synchronize: true
        });
        await server.generateFiles();
        await db_1.cleanUpTestData();
    }
};
