"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// import {Field as Field} from 'type-graphql';
const utils_1 = require("../utils");
const caller_1 = __importDefault(require("caller"));
const path_1 = __importDefault(require("path"));
const metadata_1 = require("../metadata");
// import {AdvancedOptions, ReturnTypeFunc} from 'type-graphql/dist/decorators/types';
// import {strings} from 'gluegun';
var typeorm_1 = require("typeorm");
exports.BaseModel = typeorm_1.BaseEntity;
/*interface FieldOptions {
  graphql?: {
    type?: ReturnTypeFunc;
    options?: AdvancedOptions;
  };
  orm?: ColumnOptions;
  nullable?: boolean;
}*/
function Model(_args = {}) {
    const modelFileName = caller_1.default();
    const relativeFilePath = path_1.default.relative(utils_1.generatedFolderPath(), modelFileName);
    const registerModelWithTcg = (target) => {
        metadata_1.getMetadataStorage().addModel(target.name, target, relativeFilePath);
    };
    const factories = [
        /*(<T>(target: any, propertyKey: string, descriptor: TypedPropertyDescriptor<T>): any => {
          Entity({ ...args, name: strings.pascalCase(target.name) })(target, propertyKey, descriptor);
        }) as ClassDecoratorFactory,
        ObjectType() as ClassDecoratorFactory,*/
        registerModelWithTcg
    ];
    return utils_1.composeClassDecorators(...factories);
}
exports.Model = Model;
function Enum(name, enumeration) {
    const decoratorSourceFile = caller_1.default();
    const relativeFilePath = path_1.default.relative(utils_1.generatedFolderPath(), decoratorSourceFile);
    const registerEnumWithTcg = (target, propertyKey) => {
        metadata_1.getMetadataStorage().addEnum(target.constructor.name, propertyKey, name, enumeration, relativeFilePath);
    };
    const factories = [registerEnumWithTcg];
    return utils_1.composeMethodDecorators(...factories);
}
exports.Enum = Enum;
/*export function Field(args: FieldOptions = {}): any {
  const factories = args.nullable
    ? [
      ((target: any, propertyKey: string, descriptor: PropertyDescriptor): any => {
        const _args = (args.graphql || {}).options || {};
        Field({
          ..._args,
          nullable: true,
          name: strings.camelCase(_args.name || propertyKey)
        })(target, propertyKey, descriptor);
      }) as MethodDecoratorFactory,
      ((target: any, propertyKey: string, descriptor: PropertyDescriptor): any => {
        const _args = args.orm || {};
        Column({..._args, nullable: true, name: strings.camelCase(_args.name || propertyKey)})(
          target,
          propertyKey,
          descriptor
        );
      }) as MethodDecoratorFactory
    ]
    : [
      Field((args.graphql || {}).type, (args.graphql || {}).options),
      ((target: any, propertyKey: string, descriptor: PropertyDescriptor): any => {
        const _args = args.orm || {};
        Column({..._args, name: strings.camelCase(_args.name || propertyKey)})(
          target,
          propertyKey,
          descriptor
        );
      }) as MethodDecoratorFactory
    ];
  return composeMethodDecorators(...factories);
}*/
