"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const typeorm_1 = require("typeorm");
const utils_1 = require("../utils");
const cuid_1 = __importDefault(require("cuid"));
const metadata_1 = require("../metadata");
function Id(args = {}) {
    const BeforeInsert = (target, propertyKey) => {
        target['<pk>'] = () => {
            target[propertyKey] = () => `'${cuid_1.default()}'`;
        };
        typeorm_1.BeforeInsert()(target.__proto__, '<pk>');
    };
    const registerPkWithTcg = (target, propertyKey) => {
        metadata_1.getMetadataStorage().addPk(target.constructor.name, propertyKey);
    };
    const factories = [
        typeorm_1.PrimaryColumn({
            type: String,
            readonly: true,
            ...args,
            default: '',
            nullable: false
        }),
        // Field(() => ID, { ...args, nullable: false }) as MethodDecoratorFactory,
        BeforeInsert,
        registerPkWithTcg
    ];
    return utils_1.composeMethodDecorators(...factories);
}
exports.Id = Id;
function CreatedAt(args = {}) {
    const factories = [
        typeorm_1.CreateDateColumn({
            type: Date,
            precision: 3,
            readonly: true,
            ...args,
            nullable: false
        })
        // Field(() => GraphQLISODateTime, { ...args, nullable: false }) as MethodDecoratorFactory
    ];
    return utils_1.composeMethodDecorators(...factories);
}
exports.CreatedAt = CreatedAt;
function UpdatedAt(args = {}) {
    const factories = [
        typeorm_1.UpdateDateColumn({
            type: Date,
            precision: 3,
            readonly: true,
            ...args,
            nullable: false
        })
        // Field(() => GraphQLISODateTime, { ...args, nullable: false }) as MethodDecoratorFactory
    ];
    return utils_1.composeMethodDecorators(...factories);
}
exports.UpdatedAt = UpdatedAt;
