"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MetadataStorage {
    constructor() {
        this.enumMap = {};
        this.classMap = {};
        this.pkMap = {};
    }
    addEnum(tableName, columnName, enumName, enumValues, filename) {
        this.enumMap[tableName] = this.enumMap[tableName] || {};
        this.enumMap[tableName][columnName] = {
            enumeration: enumValues,
            filename,
            name: enumName
        };
    }
    addModel(name, klass, filename) {
        this.classMap[name] = {
            filename,
            klass,
            name
        };
    }
    addPk(name, pk) {
        this.pkMap[name] = pk;
    }
    getEnum(tableName, columnName) {
        if (!this.enumMap[tableName]) {
            return undefined;
        }
        return this.enumMap[tableName][columnName] || undefined;
    }
    getModel(name) {
        if (!this.classMap[name]) {
            return undefined;
        }
        return this.classMap[name];
    }
    getPk(name) {
        return this.pkMap[name];
    }
}
exports.MetadataStorage = MetadataStorage;
function getMetadataStorage() {
    if (!global.TcgMetadataStorage) {
        global.TcgMetadataStorage = new MetadataStorage();
    }
    return global.TcgMetadataStorage;
}
exports.getMetadataStorage = getMetadataStorage;
