"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
const utils_2 = require("../../core/code-generator/utils");
function entityToService(entity) {
    const fields = [];
    const imports = [];
    entity.columns
        .filter((column) => !column.relationMetadata)
        .forEach((column) => {
        const { tsType } = utils_1.columnToTypes(column);
        const graphQLDataType = utils_1.columnTypeToGraphQLDataType(column);
        if (column.enum && !imports.includes(tsType)) {
            imports.push(tsType);
        }
        fields.push({
            name: column.propertyName,
            gclType: graphQLDataType,
            tsType,
            required: column.isNullable
        });
    });
    return utils_2.codeGeneratorUtil({
        pathToTemplate: `${__dirname}/../../cli/templates/service.ts.ejs`,
        fields,
        className: entity.name
    });
    /*entity.relations.forEach((relation: RelationMetadata) => {
      const {tsType, graphqlType} = relationToTypes(relation);
      if (!relation.inverseEntityMetadata || graphqlType.constructor !== GraphQLObjectType) return;
      const nullable = relation.isNullable ? '{ nullable: true }' : '';
      const tsRequired = relation.isNullable ? '?' : '!';
      switch (relation.relationType) {
        case 'many-to-one':
        case 'one-to-one':
          if (!imports.includes(`${graphqlType.name}`)) {
            imports.push(`${graphqlType.name}`);
          }
          fieldTemplates += `
        @Field(() => ${graphqlType.name},${nullable})
        ${relation.propertyName}${tsRequired}: ${tsType};
        `;
          break;
        case 'one-to-many':
        case 'many-to-many':
          if (!imports.includes(`${graphqlType.name}Connection`)) {
            imports.push(`${graphqlType.name}Connection`);
          }
          fieldTemplates += `
        @Field(() => ${graphqlType.name}Connection)
        ${relation.propertyName}${tsRequired}: ${graphqlType.name}Connection;
        `;
          break;
      }
    });
    return `
    import 'reflect-metadata';
    import { ArgsType, Field, Float, GraphQLISODateTime,
             ID, InputType, registerEnumType,
             GraphQLJSONObject, IDType, ConnectionArgs,
             GraphQLBoolean, GraphQLFloat, GraphQLID,
             GraphQLInt, GraphQLString, ObjectType, ${imports.join(',')} } from '../..';
    @ObjectType()
    export class ${entity.name} {
    ${fieldTemplates}
    }
    `;*/
}
exports.entityToService = entityToService;
