"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.orderBy = (query, { orderBy }, isBackward = false) => {
    if (!Array.isArray(orderBy))
        return query;
    for (const order of orderBy) {
        const parts = order.split('_');
        if (!parts.length)
            continue;
        const attr = parts[0];
        const operator = (() => {
            const result = parts[1] === 'DESC' ? parts[1] : 'ASC';
            if (isBackward) {
                if (result === 'ASC') {
                    return 'DESC';
                }
                return 'ASC';
            }
            return result;
        })();
        query.addOrderBy(`"${query.alias}"."${attr}"`, operator);
    }
    return query;
};
