"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function setTestServerEnvironmentVariables(overrides) {
    clearConfig();
    const defaultVars = getStandardEnvironmentVariables();
    Object.keys(defaultVars).forEach(key => {
        process.env[key] = defaultVars[key];
    });
    if (!overrides) {
        return;
    }
    Object.keys(overrides).forEach(key => {
        process.env[key] = overrides[key];
    });
}
exports.setTestServerEnvironmentVariables = setTestServerEnvironmentVariables;
function getStandardEnvironmentVariables() {
    return {
        TCG_APP_HOST: 'localhost',
        TCG_APP_PORT: '4000',
        TCG_APP_PROTOCOL: 'http',
        TCG_AUTO_GENERATE_FILES: 'true',
        TCG_AUTO_OPEN_PLAYGROUND: 'false',
        TCG_DB_DATABASE: 'tcg-test',
        TCG_DB_ENTITIES: 'src/test/modules/**/*.model.ts',
        TCG_DB_HOST: 'localhost',
        TCG_DB_LOGGING: 'none',
        TCG_DB_MIGRATIONS_DIR: './tmp/test/migrations',
        TCG_DB_OVERRIDE: 'true',
        TCG_DB_USERNAME: 'foo',
        TCG_DB_PASSWORD: '',
        TCG_DB_SYNCHRONIZE: 'true',
        TCG_GENERATED_FOLDER: './src/test/generated',
        TCG_RESOLVERS_PATH: './src/test/modules/**/*.resolver.ts',
        TCG_MODULE_IMPORT_PATH: '../'
    };
}
exports.getStandardEnvironmentVariables = getStandardEnvironmentVariables;
function clearConfig() {
    const TCG_PREFIX = 'TCG_';
    const TYPEORM_PREFIX = 'TYPEORM_';
    Object.keys(process.env).forEach(key => {
        if (key.startsWith(TCG_PREFIX) || key.startsWith(TYPEORM_PREFIX)) {
            delete process.env[key];
        }
    });
}
exports.clearConfig = clearConfig;
