import { Connection, DeepPartial, Repository } from 'typeorm';
import { WhereArgsType, WhereUniqueInputType } from '../../sorm/filter';
import { ClassType, ConnectionResponse } from '../types';
import { GraphQLResolveInfo } from 'graphql';
import { BaseModel } from '../../decorators';
declare class MainService<Entity extends BaseModel | any> {
    protected entityClass: ClassType<Entity>;
    protected connection: Connection;
    pk: string;
    repository: Repository<Entity>;
    constructor(entityClass: ClassType<Entity>, connection: Connection);
    findOne<WhereUniqueInput extends WhereUniqueInputType['where']>(where: WhereUniqueInput, fields?: string[]): Promise<Entity | any | undefined>;
    findMany<WhereArgs extends WhereArgsType>(args: WhereArgs, fields?: string[]): Promise<Entity[]>;
    findManyConnection<WhereArgs extends WhereArgsType>(args: WhereArgs, info: GraphQLResolveInfo | any): Promise<ConnectionResponse<Entity> | any>;
    create(data: DeepPartial<Entity> | any): Promise<Entity | any>;
    update(data: DeepPartial<Entity> | any, where: any): Promise<Entity | any>;
    updateMany(_data: DeepPartial<Entity> | any, _where: any): Promise<Entity | any>;
    delete<WhereUniqueInput extends WhereUniqueInputType['where']>(where: WhereUniqueInput): Promise<boolean>;
    deleteMany<WhereInput extends WhereArgsType['where']>(where: WhereInput): Promise<{
        count: number;
    }>;
}
export default MainService;
