"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getDatabaseName() {
    return process.env.TYPEORM_DATABASE ? process.env.TYPEORM_DATABASE : '';
}
exports.getDatabaseName = getDatabaseName;
function getDatabaseType() {
    return process.env.TYPEORM_DATABASE_TYPE ? process.env.TYPEORM_DATABASE_TYPE : 'postgres';
}
exports.getDatabaseType = getDatabaseType;
function getDatabaseHost() {
    return process.env.TYPEORM_HOST || 'localhost';
}
exports.getDatabaseHost = getDatabaseHost;
function shouldSchronizeDatabaseSchema() {
    return process.env.TYPEORM_SYNCHRONIZE === 'true';
}
exports.shouldSchronizeDatabaseSchema = shouldSchronizeDatabaseSchema;
function getDatabaseLoggingLevel() {
    return process.env.TYPEORM_LOGGING || 'all';
}
exports.getDatabaseLoggingLevel = getDatabaseLoggingLevel;
function getDatabaseEntityPaths() {
    return process.env.TYPEORM_ENTITIES
        ? process.env.TYPEORM_ENTITIES.split(',')
        : ['src/**/*.model.ts'];
}
exports.getDatabaseEntityPaths = getDatabaseEntityPaths;
function getDatabaseMigrationPaths() {
    return process.env.TYPEORM_MIGRATIONS
        ? process.env.TYPEORM_MIGRATIONS.split(',')
        : ['src/migration/**/*.ts'];
}
exports.getDatabaseMigrationPaths = getDatabaseMigrationPaths;
function getDatabaseSubscriberPaths() {
    return process.env.TYPEORM_SUBSCRIBERS
        ? process.env.TYPEORM_SUBSCRIBERS.split(',')
        : ['src/**/*.model.ts'];
}
exports.getDatabaseSubscriberPaths = getDatabaseSubscriberPaths;
function getDatabaseUsername() {
    return process.env.TYPEORM_USERNAME;
}
exports.getDatabaseUsername = getDatabaseUsername;
function getDatabasePassword() {
    return process.env.TYPEORM_PASSWORD;
}
exports.getDatabasePassword = getDatabasePassword;
function getDatabasePort() {
    return parseInt(process.env.TYPEORM_PORT || '', 10) || 5432;
}
exports.getDatabasePort = getDatabasePort;
