"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function composeMethodDecorators(...factories) {
    return (target, propertyKey, descriptor) => {
        // Reverse so that decorators are called in the order laid out at:
        // https://www.typescriptlang.org/docs/handbook/decorators.html
        factories.reverse().forEach(factory => factory(target, propertyKey, descriptor));
    };
}
exports.composeMethodDecorators = composeMethodDecorators;
function composeClassDecorators(...factories) {
    return (target) => {
        // Do NOT return anything here or it will take over the class it's decorating
        // See: https://www.typescriptlang.org/docs/handbook/decorators.html
        factories.forEach(factory => {
            return factory(target);
        });
    };
}
exports.composeClassDecorators = composeClassDecorators;
